

#ifndef HEADER_LOG_H 
#define HEADER_LOG_H 

#include <stdio.h>
#include <time.h>

FILE *fstream;

void logdata_timestamp()
{
  time_t rawtime;
  struct tm * ptm;

  time ( &rawtime );

  ptm = localtime  ( &rawtime );
  fprintf (fstream,"[%2d:%02d:%2d]", ptm->tm_hour, ptm->tm_min,ptm->tm_sec);
     
}
     
void logdata_client(const void *buf,int num)
{

   fstream = fopen("skype.log", "a+" ); 

   logdata_timestamp();
   fprintf(fstream,"%s","\nClient------------------start--------\n");
   fwrite(buf,sizeof(unsigned char),num,fstream );
   fprintf(fstream,"%s","\nClient-------------------end-------\n\n");

}

void logdata_server(const void *buf,int num)
{

   fstream = fopen("skype.log", "a+" ); 

   logdata_timestamp();
   fprintf(fstream,"%s","\nServer------------------start--------\n");
   fwrite(buf,sizeof(unsigned char),num,fstream );
   fprintf(fstream,"%s","\nServer-------------------end-------\n\n");
   fclose(fstream);

}

void logdata_generic(const char *event,LPVOID lpBuffer,DWORD len)
{
   fstream = fopen("skype.log", "a+" ); 
   fprintf(fstream,"\n---Logged event: %s",event);
   fwrite(lpBuffer,sizeof(unsigned char),len,fstream );
   fprintf(fstream,"%s","\n-------\n");
   fclose(fstream);
}

void logdata_string(const char *event,const char *info)
{
   fstream = fopen("skype.log", "a+" ); 
   fprintf(fstream,"\n---Logged event: %s",event);
   fprintf(fstream,info);
   fprintf(fstream,"%s","\n-------\n");
   fclose(fstream);
}

#endif
