

#ifndef IPelem_H
#define IPelem_H

class IPelement{
public:
  ipaddr_block *IPnum;
  string IPstring;
  bool isSuperNode;
public:
	IPelement();
	IPelement(string ip);
	IPelement(const struct sockaddr_in* to);
    string get_IPstring(){return IPstring;}
	const char* get_IPchar(){return IPstring.c_str();}
	ipaddr_block get_IPnum(){return *IPnum;}
	string num2str(long int n);

};

IPelement::IPelement()
{
    IPstring=string("");
	IPnum=new ipaddr_block();
	isSuperNode=false;
}
IPelement::IPelement(string ip)
{
    IPstring=ip;
	IPnum=new ipaddr_block(ip);
	isSuperNode=false;
}


IPelement::IPelement(const struct sockaddr_in* to)
{
   IPnum=new ipaddr_block();
   IPnum->byte1=to->sin_addr.S_un.S_un_b.s_b1;
   IPnum->byte2=to->sin_addr.S_un.S_un_b.s_b2;
   IPnum->byte3=to->sin_addr.S_un.S_un_b.s_b3;
   IPnum->byte4=to->sin_addr.S_un.S_un_b.s_b4;
   IPnum->port=to->sin_port;

   IPstring=string(inet_ntoa(to->sin_addr));
}

string IPelement::num2str(long int n)
{
   char buffer[100];
   itoa(n,buffer,10);
   return string(buffer);

}


bool operator==(const IPelement &o1,const IPelement &o2)
{
	if(o1.IPnum==o2.IPnum)
       return true;
	else 
		return false;
}


#endif