

#ifndef PacketManip_H
#define PacketManip_H
#include <memory.h>
#include <stdio.h>

class PacketManip
{
public:
   char* original_packet;
   bool last_err;
public:
   PacketManip(const char* buf,int len);
   bool RevertByte(char* buf,int b1,int b2);
};

//copy the original packet
PacketManip::PacketManip(const char* buf,int len)
{
   original_packet=new char[len];
   last_err = memcpy(original_packet,buf,len );    

}

//modify the original packet
// b1 is the index of the first byte and b2 is the index of the second byte
// buf must be preallocated first from the caller
bool PacketManip::RevertByte(char* buf,int b1,int b2)
{
	char temp;
    last_err = memcpy(original_packet,buf,sizeof(buf) );
	temp=buf[b1]; buf[b1]=buf[b2]; buf[b2]=temp;
    return last_err;   
}



#endif
