/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
originaly based from APISpy32 v2.1 from Yariv Kaplan @ WWW.INTERNALS.COM

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#pragma once
#include <windows.h>
#include <stdio.h>
#pragma warning (push)
#pragma warning(disable : 4005)// for '_stprintf' : macro redefinition in tchar.h
#include <TCHAR.h>
#pragma warning (pop)
#include "APIOverrideKernel.h"
#include "../../../linklist/linklist.h"


#include "DynamicMessageBox.h"

#define MAX_CONFIG_FILE_LINE_SIZE 1024
#define MAX_PARAM_NAME_STRING_SIZE 8
#define MAX_PARAM_FORMAT_STRING_SIZE 4

#define FIELDS_SEPARATOR '|'
///////////////////////////////////////////////////////
////////////// param direction const //////////////////
///////////////////////////////////////////////////////
#define PARAM_DIR_IN_NAME _T("IN")
#define PARAM_DIR_OUT_NAME _T("OUT")
#define PARAM_DIR_INOUT_NAME _T("INOUT")
#define PARAM_DIR_INNORET_NAME _T("INNORET")
#define PARAM_DIR_NONE_NAME _T("NONE")


///////////////////////////////////////////////////////
//////////////          functions        //////////////
///////////////////////////////////////////////////////
BOOL LoadMonitoringFile(TCHAR* pszFileName);
BOOL UnloadMonitoringFile(TCHAR* pszFileName);
BYTE GetParamFormat(DWORD ParamType);
TCHAR* GetParamName(DWORD ParamType);
DWORD GetParamType(TCHAR* pszParameter);
DWORD GetParamMask(DWORD ParamType);
TCHAR* TrimString(TCHAR* pszStr);
BOOL FirstCharOrPreviousCharSpace(TCHAR* pc,TCHAR* Origin);
struct tagAPIInfo;
void ParseAPIParameters(tagAPIInfo *pAPIInfo, TCHAR* pszLogString,DWORD pszLogStringSize,...);
void FormatString(TCHAR* pszSrcStr, TCHAR* pszDstStr, DWORD dwMaxSize);

